All of lore.kernel.org
 help / color / mirror / Atom feed
From: Junio C Hamano <gitster@pobox.com>
To: "Torsten Bögershausen" <tboegi@web.de>
Cc: Jeff King <peff@peff.net>,  "Kyle J. McKay" <mackyle@gmail.com>,
	 msysgit@googlegroups.com,
	 Git Mailing List <git@vger.kernel.org>
Subject: Re: Re: [PATCH] t/lib-httpd: switch SANITY check for NOT_ROOT
Date: Fri, 23 Jan 2015 15:02:13 -0800	[thread overview]
Message-ID: <xmqqh9vhp0cq.fsf@gitster.dls.corp.google.com> (raw)
In-Reply-To: <54C2BC01.2030307@web.de> ("Torsten Bögershausen"'s message of "Fri, 23 Jan 2015 22:24:17 +0100")

Torsten Bögershausen <tboegi@web.de> writes:

> It has been tested under Mac OS, root@Mac OS, Cygwin / Msysgit
> What do you think ?

Except that we may want to be more careful to detect errors from the
initial mkdir and clean-up part (which should abort the test, not
just declare !SANITY), I think the basic idea is sound.

	test_dir=$TRASH_DIRECTORY/.sanity-test-dir
        ! mkdir "$test_dir" &&
        >"$test_dir/x" &&
        chmod -w "$test_dir" ||
	error "bug in test sript: cannot prepare .sanity-test-dir"

        rm "$test_dir/x"
        status=$?

        chmod +w "$test_dir" &&
        rm -r "$test_dir" ||
	error "bug in test sript: cannot clean .sanity-test-dir"

	return $status

or something along that line?

>
> -- >8 --
> Subject: [PATCH 1/2] test-lib.sh: Improve SANITY
>
> SANITY was not set when running as root,
> but this is not 100% reliable for CYGWIN:
>
> A file is allowed to be deleted when the containing
> directory does not have write permissions.
>
> Signed-off-by: Torsten Bögershausen <tboegi@web.de>
> ---
>  t/test-lib.sh | 20 +++++++++++++++++++-
>  1 file changed, 19 insertions(+), 1 deletion(-)
>
> diff --git a/t/test-lib.sh b/t/test-lib.sh
> index 93f7cad..b8f736f 100644
> --- a/t/test-lib.sh
> +++ b/t/test-lib.sh
> @@ -1038,8 +1038,26 @@ test_lazy_prereq NOT_ROOT '
>  
>  # When the tests are run as root, permission tests will report that
>  # things are writable when they shouldn't be.
> +# Special check for CYGWIN (or Windows in general):
> +# A file can be deleted, even if the containing directory does'nt
> +# have write permissions
>  test_lazy_prereq SANITY '
> -	test_have_prereq POSIXPERM,NOT_ROOT
> +	dsdir=$$ds
> +	mkdir $dsdir &&
> +	touch $dsdir/x &&
> +	chmod -w $dsdir &&
> +	if rm $dsdir/x
> +	then
> +		chmod +w $dsdir
> +		rm -rf $dsdir
> +		echo >&2 SANITY=false
> +		false
> +	else
> +		chmod +w $dsdir
> +		rm -rf $dsdir
> +		echo >&2 SANITY=true
> +		true
> +	fi
>  '
>  
>  GIT_UNZIP=${GIT_UNZIP:-unzip}

-- 
-- 
*** Please reply-to-all at all times ***
*** (do not pretend to know who is subscribed and who is not) ***
*** Please avoid top-posting. ***
The msysGit Wiki is here: https://github.com/msysgit/msysgit/wiki - Github accounts are free.

You received this message because you are subscribed to the Google
Groups "msysGit" group.
To post to this group, send email to msysgit@googlegroups.com
To unsubscribe from this group, send email to
msysgit+unsubscribe@googlegroups.com
For more options, and view previous threads, visit this group at
http://groups.google.com/group/msysgit?hl=en_US?hl=en

--- 
You received this message because you are subscribed to the Google Groups "Git for Windows" group.
To unsubscribe from this group and stop receiving emails from it, send an email to msysgit+unsubscribe@googlegroups.com.
For more options, visit https://groups.google.com/d/optout.

  reply	other threads:[~2015-01-23 23:02 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-01-14 15:39 t5539 broken under Mac OS X Torsten Bögershausen
2015-01-14 18:37 ` Junio C Hamano
2015-01-14 19:50   ` Torsten Bögershausen
2015-01-14 21:17     ` Jeff King
2015-01-15  5:48       ` Kyle J. McKay
2015-01-15 20:29         ` Junio C Hamano
2015-01-15 22:27           ` Jeff King
2015-01-15 22:39             ` Junio C Hamano
2015-01-15 23:57               ` Jeff King
2015-01-16  0:04                 ` Junio C Hamano
2015-01-16  1:32                   ` [PATCH] t/lib-httpd: switch SANITY check for NOT_ROOT Jeff King
2015-01-16  3:27                     ` Kyle J. McKay
2015-01-16  3:34                       ` Jeff King
2015-01-16  9:16                         ` Jeff King
2015-01-16 18:32                           ` Junio C Hamano
2015-01-16 19:02                             ` Junio C Hamano
2015-01-17 23:35                               ` Torsten Bögershausen
2015-01-21 22:33                                 ` Junio C Hamano
2015-01-22 21:51                                   ` Torsten Bögershausen
2015-01-22 22:07                                     ` Junio C Hamano
2015-01-23  6:00                                       ` Torsten Bögershausen
2015-02-12 22:36                                         ` Junio C Hamano
2015-02-14  8:36                                           ` [msysGit] " Torsten Bögershausen
2015-02-15 23:48                                             ` Junio C Hamano
2015-01-23 21:24                                       ` [msysGit] " Torsten Bögershausen
2015-01-23 23:02                                         ` Junio C Hamano [this message]
2015-01-24  9:41                                         ` Johannes Schindelin
2015-01-16 18:38                           ` Kyle J. McKay
2015-01-16 18:38                         ` Kyle J. McKay
2015-01-16 20:04                           ` Achim Gratz
2015-01-27  1:44                   ` t5539 broken under Mac OS X Erik Faye-Lund
2015-01-27  2:51                     ` Junio C Hamano
2015-01-27 16:35                       ` Erik Faye-Lund

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=xmqqh9vhp0cq.fsf@gitster.dls.corp.google.com \
    --to=gitster@pobox.com \
    --cc=git@vger.kernel.org \
    --cc=mackyle@gmail.com \
    --cc=msysgit@googlegroups.com \
    --cc=peff@peff.net \
    --cc=tboegi@web.de \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.